﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Security;

namespace WebApplication1
{
	// *************************************************************************
	// *** MyRole **************************************************************
	// *************************************************************************
	[Flags]
	public enum MyRole
	{
		Admin = 1,
		User = 2,
		Manager = 4
	} // public enum MyRole

	// *************************************************************************
	// *** CustomRoleManager ***************************************************
	// *************************************************************************
	public class CustomRoleManager : RoleProvider
	{
		// ---------------------------------------------------------------------
		// --- AccessElmhurstRoleProvider Proprties ----------------------------
		// ---------------------------------------------------------------------
		public override string ApplicationName
		{
			get { return "default"; }
			set { throw new NotSupportedException(); }
		}

		// ---------------------------------------------------------------------
		// --- AccessElmhurstRoleProvider Methods ------------------------------
		// ---------------------------------------------------------------------
		public override void AddUsersToRoles(string[] usernames, string[] roleNames)
		{
			throw new NotSupportedException();
		}

		// ---------------------------------------------------------------------
		public override void CreateRole(string roleName)
		{
			throw new NotSupportedException();
		}

		// ---------------------------------------------------------------------
		public override bool DeleteRole(string roleName, bool throwOnPopulatedRole)
		{
			throw new NotSupportedException();
		}

		// ---------------------------------------------------------------------
		public override string[] FindUsersInRole(string roleName, string usernameToMatch)
		{
			throw new NotSupportedException();
		}

		// ---------------------------------------------------------------------
		public override string[] GetAllRoles()
		{
			return Enum.GetValues(typeof(MyRole)).Cast<MyRole>().Select(item => item.ToString()).ToArray();
		}

		// ---------------------------------------------------------------------
		public override string[] GetRolesForUser(string username)
		{
			if (!WebFormLogin.Uzivatelia.ContainsKey(username))
				throw new NotSupportedException();

			bool jeAdmin = (username == "admin");
			var definiciaUzivatela = WebFormLogin.Uzivatelia[username];

			// Prejdeme roly a ak su definovane pre dane konto, tak ich priradime
			var roly = new List<string>();
			foreach (MyRole aktualnaRola in Enum.GetValues(typeof(MyRole)))
			{
				if ((definiciaUzivatela.Item2 & aktualnaRola) == aktualnaRola || jeAdmin)
					roly.Add(aktualnaRola.ToString());
			} // foreach

			return roly.ToArray();
		}

		// ---------------------------------------------------------------------
		public override string[] GetUsersInRole(string roleName)
		{
			throw new NotSupportedException();
		}

		// ---------------------------------------------------------------------
		public override bool IsUserInRole(string username, string roleName)
		{
			throw new NotSupportedException();
		}

		// ---------------------------------------------------------------------
		public override void RemoveUsersFromRoles(string[] usernames, string[] roleNames)
		{
			throw new NotSupportedException();
		}

		// ---------------------------------------------------------------------
		public override bool RoleExists(string roleName)
		{
			return GetAllRoles().Contains(roleName);
		}
	} // public class CustomRoleManager

} // namespace WebApplication1